! Author: Chris Bordeman
! Email:  chrisbordeman@hotmail.com

 member

 include('InfoZip.inc'), once
 include('CWSYNCHC.INC'), once

 map
     module('Some built in funcs')
         iz__lstrlen(ulong SourcePtr),long,pascal,name('lstrlen')
         iz__strncpy(ulong TargetPtr, ulong SourcePtr, ulong NumBytes),long,proc,pascal,name('_strncpy')

         !PathSplit(*CSTRING path, *CSTRING drive, *CSTRING dir, *CSTRING fn, *CSTRING ext), SIGNED, PROC, RAW, NAME('_fnsplit')
         !PathMerge(*CSTRING path, *CSTRING drive, *CSTRING dir, *CSTRING fn, *CSTRING ext), SIGNED, PROC, RAW, NAME('_fnmerge')
     end

zDLLPRNT procedure(ulong, long zSize), long, pascal
zDLLPASSWORD procedure(ulong PwdBuf, long PwdBufSize, ulong PwdPrompt, ulong EntryName), long, pascal
zDLLSERVICE procedure(ulong zFN, long zSize), long, pascal
uzDLLMESSAGE procedure(ulong ucsize, ulong csize, ulong cfactor, |
                      ulong mo, ulong dy, ulong yr, ulong hh, ulong mm, |
                      byte convertedtolowercase, ulong filename, ulong cmethod, ulong crc32, |
                      byte fCrypt),pascal
zDLLCOMMENT procedure(ulong CommentStr), pascal
zDLLREPLACE procedure(ulong str),long,pascal
 end


! *********************************************************************************************************************
! *********************************************************************************************************************
! stub callback functions used by InfoZipClass
! *********************************************************************************************************************
! *********************************************************************************************************************

! *********************************************************************************************************************
! *********************************************************************************************************************
! THIS CALLBACK IS REQUIRED
! *********************************************************************************************************************
zDLLPRNT procedure(ulong txt, long zSize)
tmpcstr &cstring
emptycstr cstring('')
 code
 yield
 if zSize <= 0
     !message('zDLLPRNT, zSize=0')
     tmpcstr &= emptycstr
 else
     tmpcstr &= (txt&':'&zSize)  !iz__lstrlen(txt))
 end     
 return ActiveInfoZip.PrintCallback(tmpcstr)


! *********************************************************************************************************************
! *********************************************************************************************************************
zDLLPASSWORD procedure(ulong PwdBuf, long PwdBufSize, ulong PwdPrompt, ulong EntryName)
tmpcstr1 &cstring
tmpcstr2 &cstring
tmpcstr3 &cstring
 code
 tmpcstr1 &= (PwdBuf&':'& PwdBufSize)
 tmpcstr2 &= (PwdPrompt&':'& iz__lstrlen(PwdPrompt))
 tmpcstr3 &= (EntryName&':'& iz__lstrlen(EntryName))
 return ActiveInfoZip.PasswordCallback(tmpcstr1, PwdBufSize, tmpcstr2, tmpcstr3)


! *********************************************************************************************************************
! *********************************************************************************************************************
zDLLSERVICE procedure(ulong zFN, long zSize)
tmpcstr &cstring
 code
 !message('zDLLSERVICE')
 tmpcstr &= (zFN&':'& iz__lstrlen(zFN))
 return ActiveInfoZip.ServiceCallback(tmpcstr, zSize)
 

! *********************************************************************************************************************
! *********************************************************************************************************************
! THIS CALLBACK IS REQUIRED
! *********************************************************************************************************************
zDLLCOMMENT procedure(ulong CommentStr)
tmpcstr &cstring
 code
 yield
 !message('zDLLCOMMENT')
 tmpcstr &= (CommentStr&':'& iz__lstrlen(CommentStr))
 !message('zDLLCOMMENT: CommentStr='&CommentStr&', tmpcstr='&tmpcstr)
 ActiveInfoZip.CommentCallback(tmpcstr)


! *********************************************************************************************************************
! *********************************************************************************************************************
! THIS CALLBACK IS REQUIRED
! *********************************************************************************************************************
uzDLLMESSAGE procedure(ulong ucsize, ulong csize, ulong cfactor, |
                       ulong mo, ulong dy, ulong yr, ulong hh, ulong mm, |
                       byte convertedtolowercase, ulong filename, ulong cmethod, ulong crc32, |
                       byte fCrypt)

fn &cstring
 code
 yield
 !message('zDLLMESSAGE')
 fn &= (filename&':'&iz__lstrlen(filename))
 !message('zDLLMESSAGE: fn='&fn&', ucsize='&ucsize&', csize='&csize&', cfactor='&cfactor&', convertedtolowercase='&convertedtolowercase& |
 !        ', fCrypt='&fCrypt&', crc32='&crc32)
 ActiveInfoZip.MessageCallback(fn, ucsize, csize, cfactor)


! *********************************************************************************************************************
! *********************************************************************************************************************
! THIS CALLBACK IS REQUIRED
! *********************************************************************************************************************
zDLLREPLACE procedure(ulong str)
tmpcstr &cstring
 code
 !message('zDLLREPLACE')
 tmpcstr &= (str&':'& iz__lstrlen(str))
 return 1


! **********************************************************************************************************
! **********************************************************************************************************
! implementation of InfoZipClass
! **********************************************************************************************************
! **********************************************************************************************************

! *********************************************************************************************************************
! *********************************************************************************************************************
InfoZipClass.MessageCallback procedure(*cstring fn, ulong ucsize, ulong csize, ulong cfactor)
 code
 clear(self.ContentQ)
 self.ContentQ.FN = fn
 self.ContentQ.UncompressedSize = ucsize
 self.ContentQ.CompressedSize = csize
 self.ContentQ.CompressionFactor = cfactor
 add(self.ContentQ)


! *********************************************************************************************************************
! *********************************************************************************************************************
InfoZipClass.PrintCallback procedure(*cstring txt)
 code

 !message('InfoZipClass.PrintCallback(), txt='&txt&'||self.zpPrgBarFEQ PROP:RangeHigh='&self.zpPrgBarFEQ{PROP:RangeHigh}&', self.zpPrgBarFEQ PROP:Progress='&self.zpPrgBarFEQ{PROP:Progress})

 if self.NoUI = true or self.Operation = 2 then return 0.

 if len(txt) > 0
     !if self.CurrentOperation = 2 then message('in .PrintCallback(): txt='&txt).
     
     case sub(txt,1,1)
     of ' ' orof '<9>'         
         if self.zpPrgStrFEQ then self.zpPrgStrFEQ{PROP:Text} = clip(left(sub(txt,2,len(txt)-1))).

     of '<10>' orof '<13>'
     of '.'
         if self.zpPrgBarFEQ
             self.zpPrgBarFEQ{PROP:Progress} = self.zpPrgBarFEQ{PROP:Progress} + (32768)
         end
     of '('
     else
         !if self.zpPrgStrFEQ then self.zpPrgStrFEQ{PROP:Text} = clip(left(txt)).
     end
 end
 display(self.zpPrgStrFEQ)
     
 ! returns: printed chars
 return 0

! *********************************************************************************************************************
! *********************************************************************************************************************
InfoZipClass.PasswordCallback procedure(*cstring PwdBuf, long PwdBufSize, *cstring PwdPrompt, *cstring EntryName)
 code
 !return value: 0 = there is a password, negative = user abort; positive = error
 return 1

! *********************************************************************************************************************
! *********************************************************************************************************************
InfoZipClass.ServiceCallback procedure(*cstring zFN, long zSize)
 code

 if self.NoUI = true or self.Operation = 2 then return 0.

 !message('.ServiceCallback(): zFN='&zFN&', zSize = '&zSize)

 if zSize > 0
     case sub(zFN,1,1)
     of '<10>' orof '<13>'
     else
         ! zSize is the size of the output file
         if self.zpPrgStrFEQ
             self.zpPrgStrFEQ{PROP:Text} = clip(zFN)
             !display(self.zpPrgStrFEQ)
         end

         self.TotalBytesSoFar += zSize
         if self.zpPrgBarFEQ
             self.zpPrgBarFEQ{PROP:Progress} = self.TotalBytesSoFar
         end
     end
 end

 ! return non-zero means terminate zip/unzip loop
 return 0


! *********************************************************************************************************************
! *********************************************************************************************************************
InfoZipClass.CommentCallback procedure(*cstring CommentStr)
 code


! *********************************************************************************************************************
! *********************************************************************************************************************
InfoZipClass.ErrStr procedure(long ErrNo)
RetStr string(255)
 code
 case ErrNo
 of  ZE_MISS
     return 'Error used by procname(), zipbare()'
 of  ZE_OK
     return 'Success'
 of  ZE_EOF
     return 'Unexpected end of zip file'
 of  ZE_FORM
     return 'Zip file structure error'
 of  ZE_MEM
     return 'Out of memory'
 of  ZE_LOGIC
     return 'Internal logic error'
 of  ZE_BIG
     return 'Entry too large to split, read, or write'
 of  ZE_NOTE
     return 'Invalid comment format'
 of  ZE_TEST
     return 'Zip test (-T) failed or out of memory'
 of  ZE_ABORT
     return 'User interrupt or termination'
 of  ZE_TEMP
     return 'Error using a temp file'
 of  ZE_READ
     return 'Read or seek error'
 of  ZE_NONE
     return 'Nothing to do'
 of  ZE_NAME
     return 'Missing or empty zip file'
 of  ZE_WRITE
     return 'Error writing to a file'
 of  ZE_CREAT
     return 'Couldn''t open to write.'
 of  ZE_PARMS
     return 'Bad command line'
 of  ZE_OPEN
     return 'Could not open a specified file to read'
 else
     return 'Should not see this error'
 end


! *********************************************************************************************************************
! *********************************************************************************************************************
InfoZipClass.CalcPatternSize procedure(string fPattern)
FQ queue(FILE:Queue), pre(FQ)
   end
SumSize decimal(31)
i long
 code
 directory(FQ, self.RootPath&fPattern, ff_:NORMAL+ff_:READONLY+ff_:SYSTEM+ff_:ARCHIVE+ff_:HIDDEN)
 loop i = 1 to records(FQ)
     get(FQ, i)
     SumSize += FQ.Size
 end 
 return SumSize


! *********************************************************************************************************************
! *********************************************************************************************************************
InfoZipClass.Init procedure
 code
 self.StatusWindow &= InfoZipStatusWindow
 
 self.TotalSize      = 0
 self.zpPrgBarFEQ    = ?IZ__Progress
 self.zpPrgStrFEQ    = ?IZ__StatusTxt
 clear(self.ZUF)
 clear(self.UZUF)
 clear(self.ZCL)

 ! THIS CALLBACK IS REQUIRED, OR ZPINIT() WILL FAIL
 ! General message routine (reports, errors - no status!), returns: printed chars.
 self.ZUF.print = Address(zDLLPRNT)
 self.UZUF.print = Address(zDLLPRNT)

 ! The application's sound routine.  This can be NULL if your application doesn't use sound.
 !self.ZUF.ufsound                  = 0 !Address(zDLLSND)
  
 ! The application's replace routine.
 !self.ZUF.replace                = Address(zDLLREPLACE)
 self.UZUF.replace                = Address(zDLLREPLACE)

 ! Return value: 0 = there is a password, negative = user abort; positive = error.
 !self.ZUF.password = address(zDLLPASSWORD)

 ! THIS CALLBACK IS REQUIRED, OR ZPINIT() WILL FAIL
 ! The message routine for displaying information about specific files in the archive.
 ! Used for listing the contents of an archive.
 self.ZUF.comment = address(zDLLCOMMENT)
 self.UZUF.Message = address(uzDLLMESSAGE)
 
 ! Status report callback, return value: nonzero = terminate.  Allows the application to process Windows messages,
 ! or canceling the operation, as well as giving the option of a progress indicator. If this function returns
 ! a non-zero value, then it will terminate what it is doing. It provides the application with the name of the
 ! name of the archive member it has just processed, as well as it's original size.
 self.ZUF.ServiceApplication = address(zDLLSERVICE)
 self.UZUF.ServiceApplication = address(zDLLSERVICE)
 
 ! set standard options 
 clear(self.ZO)
 self.ZO.Date           = 0                 ! LPSTR Date to include after
 self.ZO.szRootDir = address(self.RootPath) ! LPSTR Directory to use as base for zipping
 self.ZO.szTempDir      = 0                 ! LPSTR Temporary directory used during zipping
 self.ZO.fTemp          = false             ! BOOL Use temporary directory '-b' during zipping
 self.ZO.fSuffix        = false             ! BOOL include suffixes (not implemented)
 self.ZO.fEncrypt       = false             ! BOOL encrypt files
 self.ZO.fSystem        = true              ! BOOL include system and hidden files
 self.ZO.fVolume        = false             ! BOOL Include volume label
 self.ZO.fExtra         = true              ! BOOL Exclude extra attributes
 self.ZO.fNoDirEntries  = false             ! BOOL Do not add directory entries
 self.ZO.fExcludeDate   = false             ! BOOL Exclude files newer than specified date
 self.ZO.fIncludeDate   = false             ! BOOL Include only files newer than specified date
 self.ZO.fVerbose       = true              ! BOOL Mention oddities in zip file structure - NECESSARY FOR PROGRESS BAR
 self.ZO.fQuiet         = false             ! BOOL Quiet operation
 self.ZO.fCRLF_LF       = false             ! BOOL Translate CR/LF to LF
 self.ZO.fLF_CRLF       = false             ! BOOL Translate LF to CR/LF
 self.ZO.fJunkDir       = false             ! BOOL Discard directory names - will get error if duped filenames
 self.ZO.fGrow          = true              ! BOOL Allow appending to a zip file
 self.ZO.fForce         = false             ! BOOL Make entries using DOS names (k for Katz)
 self.ZO.fMove          = false             ! BOOL Delete files added or updated in zip file
 self.ZO.fDeleteEntries = false             ! BOOL Delete files from zip file
 self.ZO.fUpdate        = false             ! BOOL Update zip file--overwrite only if newer
 self.ZO.fFreshen       = false             ! BOOL Freshen zip file--overwrite only
 self.ZO.fJunkSFX       = false             ! BOOL Junk SFX prefix
 self.ZO.fLatestTime    = false             ! BOOL Set zip file time to time of latest file in it
 self.ZO.fComment       = false             ! BOOL Put comment in zip file
 self.ZO.fOffsets       = false             ! BOOL Update archive offsets for SFX files
 self.ZO.fPrivilege     = true              ! BOOL Use privileges (WIN32 only)
 self.ZO.fEncryption    = false             ! BOOL TRUE if encryption supported, else FALSE. this is a read only flag
 self.ZO.fRecurse       = 0                 ! long Recurse into subdirectories. 1 => -r, 2 => -R
 self.ZO.fRepair        = 0                 ! long Repair archive. 1 => -F, 2 => -FF
 self.ZO.fLevel         = '6'               ! string(1) Compression level ('0' - '9')


! *********************************************************************************************************************
! *********************************************************************************************************************
InfoZipClass.Kill procedure
 code


! *********************************************************************************************************************
! *********************************************************************************************************************
InfoZipClass.AddToArchive procedure( |
               string WindowTitle, |
               string ArchiveFilename, |
               string RootDir, |          ! '' current directory
               string FileList, |         ! semicolon separated list, wildcards ok               
               byte CreateZip |           ! if true, archive is deleted first
               )                          ! 0 = success
j long
i long
MyParseQ queue(InfoZipParseQType), pre(MYPARSEQ)
         end
RetVal                    bool(true)   ! RetVal <> false means error
ind                       ulong        ! index of current queue item
cptr                      ulong        ! ptr to current string at szFileList
ciptr                     ulong        ! index ptr at beginning of szFileList
cl                        ulong        ! length of current string

elements long(2)
ZipNames ulong,dim(32*1024) !(elements)  ! using dynamic arrays is causing stack corruption and GPF

path  cstring(513)
drive cstring(513)
dir   cstring(513)
fn    cstring(513)
ext   cstring(513)

along long

tmpcstrref &cstring
   
LocalVars           group,Pre(Loc)
OutputHandle            signed
InputHandle             signed
InBuffer                cString(100)
OutBuffer               cString(100)
BytesWritten            ulong
BytesRead               ulong
                    end
 code

 ActiveInfoZip &= self
 self.Operation = 1

 if RootDir = ''
     self.RootPath = clip(longpath())
 else
     self.RootPath = clip(RootDir)
 end
 if self.RootPath[len(clip(self.RootPath))] <> '\' then self.RootPath = self.RootPath & '\'.
 
 if FileList = ''
     if not self.NoUI then message('Cannot create archive, no files specified to add.', '', Icon:Exclamation).
     return 1
 end

 self.ParseStringIntoQueue(FileList, MyParseQ)
 if records(MyParseQ) = 0
     if not self.NoUI then message('Cannot create archive, no files found to add.', '', Icon:Exclamation).
     return 1
 end
 !message('records(MyParseQ)='&records(MyParseQ))

 self.ArchiveFN = clip(ArchiveFilename)

 if exists(self.ArchiveFN)
     remove(self.ArchiveFN)
     if errorcode()
         if not self.NoUI then message('Could not delete '&self.ArchiveFN&'.||Error: '&clip(error()), 'Error', Icon:Exclamation).
         return 1
     end
 end

 open(self.StatusWindow)
 if not self.NoUI
     display
     if WindowTitle <> ''
         self.StatusWindow{Prop:Text} = clip(WindowTitle)
     else
         self.StatusWindow{Prop:Text} = 'Creating '&self.ArchiveFN&'...'
     end
 end

 !ZpVersion(self.ZV)
 !message('Windows DLL version: '&self.ZV.windll.major&'.'&self.ZV.windll.minor&'.'&self.ZV.windll.patchlevel)

 clear(self.ZCL)
 RetVal = true
 self.ZCL.argc = records(MyParseQ)
 elements = self.ZCL.argc + 2  ! the C routines apparently expect at least one null past the end
 clear(ZipNames)
 self.TotalSize = 0
 self.TotalBytesSoFar = 0
 if self.ZCL.argc
     x# = ZpInit(address(self.ZUF))
     if not x#
         if not self.NoUI then message('could not initialize InfoZip', 'InfoZip Error', Icon:Exclamation).
         return 1
     else
         clear(ZipNames)
         loop ind = 1 to self.ZCL.argc
             get(MyParseQ,ind)
             if errorcode() then break.

             tmpcstrref &= new cstring(len(clip(MyParseQ.Tok))+1)
             clear(tmpcstrref)
             tmpcstrref = clip(MyParseQ.Tok)
             ZipNames[ind] = address(tmpcstrref)
             self.TotalSize += self.CalcPatternSize(MyParseQ.Tok)
         end
     
         x# = ZpSetOptions(address(self.ZO))
         
         self.ZCL.lpszZipFN  = address(self.ArchiveFN)
         self.ZCL.FNV        = address(ZipNames)

         !message('self.TotalSize='&self.TotalSize)
         if self.zpPrgBarFEQ then self.zpPrgBarFEQ{PROP:RangeHigh} = self.TotalSize.
         RetVal = ZpArchive(self.ZCL)
         loop ind = 1 to self.ZCL.argc
             if ZipNames[ind]
                 tmpcstrref &= (ZipNames[ind])
                 dispose(tmpcstrref)
             end
         end         
         !message('CreateArchive(): RetVal='&RetVal&': '&self.ErrStr(RetVal))
     end
 end

 close(self.StatusWindow)
 return(RetVal)


! *********************************************************************************************************************
! *********************************************************************************************************************
InfoZipClass.ExtractArchive procedure( |
        string WindowTitle, |
        string ArchiveFilename, |
        string FileList, |        ! semicolon separated files to extract (wildcards ok)
        string ExtractBaseDir |   ! directory extracted into
        )                         ! 0 = success

RetVal   long
elements long(1)
ZipNames ulong,dim(elements)
tmpcstrref &cstring

j long
MyParseQ queue(InfoZipParseQType), pre(MYPARSEQ)
         end
LocalContentQ queue(InfoZipContentQType)
              end
 code

 ActiveInfoZip &= self
 self.Operation = 4

 self.ArchiveFN = clip(ArchiveFilename)

 if not exists(self.ArchiveFN)
     if not self.NoUI then message('Could not extract '&self.ArchiveFN&' because the file does not exist.', 'Error', Icon:Exclamation).
     return 1
 end

 self.ParseStringIntoQueue(FileList, MyParseQ)
 elements = records(MyParseQ)
 if elements = 0
     if not self.NoUI then message('Cannot extract archive, no files given to extract.', '', Icon:Exclamation).
     return 1
 end

 if ExtractBaseDir = ''
     self.RootPath = ''
 else
     self.RootPath = clip(ExtractBaseDir)
     if self.RootPath[len(clip(self.RootPath))] <> '\' then self.RootPath = self.RootPath & '\'.
 end

 RetVal = self.GetContents(self.ArchiveFN, LocalContentQ)
 if RetVal then return RetVal.

 self.TotalSize = self.UZUF.lTotalSize
 self.TotalSizeCompressed = self.UZUF.lTotalSizeComp
 self.TotalBytesSoFar = 0

 open(self.StatusWindow)
 if not self.NoUI
     display
     if WindowTitle <> ''
         self.StatusWindow{Prop:Text} = clip(WindowTitle)
     else
         self.StatusWindow{Prop:Text} = 'Extracting '&self.ArchiveFN&'...'
     end
 end

 if self.zpPrgBarFEQ then self.zpPrgBarFEQ{PROP:RangeHigh} = self.TotalSize.

 clear(ZipNames)
 loop j = 1 to elements
     get(MyParseQ, j)
     if errorcode() then break.

     tmpcstrref &= new cstring(len(clip(MyParseQ.Tok))+1)
     tmpcstrref = clip(MyParseQ.Tok)
     ZipNames[j] = address(tmpcstrref)
 end

 clear(self.DCL)
 self.DCL.noflag = 1
 self.DCL.C_flag = 1                                                         ! case insensitive if 1
 self.DCL.lpszZipFN = address(self.ArchiveFN)                                ! the archive name 
 self.DCL.lpszExtractDir = choose(self.RootPath='',0,address(self.RootPath)) ! NULL if current directory

 self.Operation = 4
 RetVal = Wiz_SingleEntryUnzip(elements, address(ZipNames), 0, 0, self.DCL, self.UZUF)
 !message('Wiz_SingleEntryUnzip() returned '&RetVal&': '&self.ErrStr(RetVal)&', lTotalSize='&self.UZUF.lTotalSize&', lTotalSizeComp='&self.UZUF.lTotalSizeComp)

 loop j = 1 to elements
     if ZipNames[j]
         tmpcstrref &= (ZipNames[j])
         dispose(tmpcstrref)
     end
 end

 close(self.StatusWindow)
 return(RetVal)


! *********************************************************************************************************************
! *********************************************************************************************************************
InfoZipClass.ParseStringIntoQueue procedure(string s, InfoZipParseQType PARSEQ:LocalParseQ)
l long
j long
p long(1)
lt long(size(PARSEQ:Tok))
 code

 free(LocalParseQ)
 clear(LocalParseQ)

 l = len(clip(s))

 if l = 0 then return.

 clear(PARSEQ:Tok)
 loop j = 1 to l
     if s[j] = ';'
         PARSEQ:Tok = clip(PARSEQ:Tok)
         add(LocalParseQ)    
         !message('InfoZipClass.ParseStringIntoQueue(), added PARSEQ:Tok='&clip(PARSEQ:Tok)&'||records(LocalParseQ)='&records(LocalParseQ))
         clear(PARSEQ:Tok)
         p = 1
     else
         PARSEQ:Tok[p] = s[j]
         p += 1
         if p > lt then break.
     end
 end
 PARSEQ:Tok = clip(PARSEQ:Tok)
 add(LocalParseQ)
 !message('InfoZipClass.ParseStringIntoQueue(), added PARSEQ:Tok='&clip(PARSEQ:Tok)&'||records(LocalParseQ)='&records(LocalParseQ))


! *********************************************************************************************************************
! *********************************************************************************************************************
InfoZipClass.GetContents procedure(string ArchiveFilename, InfoZipContentQType CONTENTQ:LocalContentQ) ! 0 success

RetVal                    bool(true)   ! RetVal <> false means error

 code

 ActiveInfoZip &= self
 self.ContentQ &= LocalContentQ
 free(self.ContentQ)
 self.Operation = 2

 self.ArchiveFN = clip(ArchiveFilename)

 clear(self.DCL)
 self.DCL.ncflag = 0              ! Write to stdout if true 
 self.DCL.fQuiet = 0              ! We want all messages.
                                  ! 1 = fewer messages,
                                  ! 2 = no messages 
 self.DCL.ntflag = 0              ! test zip file if true 
 self.DCL.nvflag = 1              ! give a verbose listing if true 
 self.DCL.nzflag = 0              ! display a zip file comment if true
 self.DCL.ndflag = 0              ! Recreate directories != 0, skip "../" if < 2
 self.DCL.naflag = 0              ! Do not convert CR to CRLF 
 self.DCL.nfflag = 0              ! Do not freshen existing files only 
 self.DCL.noflag = 0              ! Over-write all files if true
 self.DCL.C_flag = 1              ! case insensitive if 1
 self.DCL.ExtractOnlyNewer = 0    ! Extract only newer 
 self.DCL.PromptToOverwrite = 0   ! "Overwrite all" selected -> no query mode 
 self.DCL.nZIflag = 0             ! get Zip info
 self.DCL.lpszZipFN = address(self.ArchiveFN) ! The archive name
 self.DCL.lpszExtractDir = 0      ! The directory to extract to. This is set
                                  ! to NULL if you are extracting to the
                                  ! current directory

 open(self.StatusWindow)

 RetVal = Wiz_SingleEntryUnzip(0, 0, 0, 0, self.DCL, self.UZUF);
 !message('GETTING LISTING: Wiz_SingleEntryUnzip() returned '&RetVal&': '&self.ErrStr(RetVal)&', lTotalSize='&self.UZUF.lTotalSize&', lTotalSizeComp='&self.UZUF.lTotalSizeComp)

 self.TotalSize = self.UZUF.lTotalSize
 self.TotalSizeCompressed = self.UZUF.lTotalSizeComp

 !if self.zpPrgBarFEQ then self.zpPrgBarFEQ{PROP:RangeHigh} = self.TotalSize.
 if RetVal
     if not self.NoUI then message('Could not read directory of archive, error '&RetVal&': '&self.ErrStr(RetVal)).
     close(self.StatusWindow)
     return RetVal
 end
 
 close(self.StatusWindow)
 return RetVal


! *********************************************************************************************************************
! *********************************************************************************************************************
InfoZipClass.UnzipToUzpBuffer procedure(string zip, string filename, *UzpBuffer uzpbuf, <string WindowTitle>)
RetVal        long
found         long
i             long
zipcstr       cstring(512)
filenamecstr  cstring(512)
LocalContentQ queue(InfoZipContentQType)
              end

 code

 ActiveInfoZip &= self
 self.ContentQ &= LocalContentQ
 free(self.ContentQ)
 
 self.ArchiveFN = clip(zip)
 
 if not exists(self.ArchiveFN)
     if not self.NoUI then message('Archive '&self.ArchiveFN&' does not exist.', 'Error', Icon:Exclamation).
     return 1
 end
 
 RetVal = self.GetContents(zip, LocalContentQ)
 if RetVal then return RetVal.
 self.Operation = 3  ! was modified by GetContents() call
 
 open(self.StatusWindow)
 if not self.NoUI
     display
     if not omitted(WindowTitle) and WindowTitle <> ''
         self.StatusWindow{Prop:Text} = clip(WindowTitle)
     else
         self.StatusWindow{Prop:Text} = 'Extracting '&self.ArchiveFN&'...'
     end
 end
 
 ! Wiz_UnzipToMemory() is slash-style and and case-sensitive.  Normalize the slashes
 ! and case to match what's in the archive.
 loop i = 1 to len(clip(filename))
     if filename[i] = '\'
         filename[i] = '/'
     end
 end
 loop i = 1 to records(LocalContentQ)
     get(LocalContentQ, i)
     if clip(upper(LocalContentQ.FN)) = clip(upper(filename))
         filename = LocalContentQ.FN
         found = true
         break
     end
 end
 if not found
     if not self.NoUI then message(''''&clip(filename)&''' was not found in archive '''&clip(zip)&'''.', 'Error', Icon:Exclamation).     
     close(self.StatusWindow)
     return 1
 end

 if self.zpPrgBarFEQ then self.zpPrgBarFEQ{PROP:RangeHigh} = LocalContentQ.UncompressedSize.
 self.TotalBytesSoFar = 0

 zipcstr      = clip(zip)
 filenamecstr = clip(filename)
 RetVal = Wiz_UnzipToMemory(address(zipcstr), address(filenamecstr), self.UZUF, UzpBuf)
 if RetVal = 0  ! 0 indicates error
     if not self.NoUI then message('Could not extract '''&filenamecstr&''' from archive '''&zipcstr&'''', 'Error', Icon:Exclamation).
     close(self.StatusWindow)
     return 1
 end
 
 close(self.StatusWindow)
 return 0


! *********************************************************************************************************************
! *********************************************************************************************************************
InfoZipClass.UnzipToCString procedure(string zip, string filename, *cstring filebuf, <string WindowTitle>)
UzpBuf like(UzpBuffer)
RetVal long
cs &cstring
 code

 clear(UzpBuf)
 if omitted(WindowTitle)
     RetVal = self.UnzipToUzpBuffer(zip, filename, UzpBuf)
 else
     RetVal = self.UnzipToUzpBuffer(zip, filename, UzpBuf, WindowTitle)
 end

 if RetVal = 0 and UzpBuf.strptr <> 0
     cs &= (UzpBuf.strptr&':'&UzpBuf.strlength)
     filebuf = cs
     self.FreeUzpBuffer(UzpBuf)
 else
     clear(filebuf)
 end

 return RetVal


! *********************************************************************************************************************
! *********************************************************************************************************************
InfoZipClass.FreeUzpBuffer procedure(*UzpBuffer uzpbuf)
 code
 if uzpbuf.strptr
     UzpFreeMemBuffer(uzpbuf)
     uzpbuf.strptr    = 0
     uzpbuf.strlength = 0
 end
