OMIT('_EndOfInclude_',_InfoZipPresent_)
_InfoZipPresent_ equate(1)

 map
     module('InfoZip.CLW')
     end
 end

! include('windows.inc'), once

! codes returned by InfoZipClass
IZ_OK equate(0)
IZ_ERROR equate(1)
IZ_CANCELLED equate(2)

! error codes from InfoZip
ZE_MISS         Equate(-1)      ! used by procname(), zipbare()
ZE_OK           Equate(0 )      ! success
ZE_EOF          Equate(2 )      ! unexpected end of zip file
ZE_FORM         Equate(3 )      ! zip file structure error
ZE_MEM          Equate(4 )      ! out of memory
ZE_LOGIC        Equate(5 )      ! internal logic error
ZE_BIG          Equate(6 )      ! entry too large to split, read, or write
ZE_NOTE         Equate(7 )      ! invalid comment format
ZE_TEST         Equate(8 )      ! zip test (-T) failed or out of memory
ZE_ABORT        Equate(9 )      ! user interrupt or termination
ZE_TEMP         Equate(10)      ! error using a temp file
ZE_READ         Equate(11)      ! read or seek error
ZE_NONE         Equate(12)      ! nothing to do
ZE_NAME         Equate(13)      ! missing or empty zip file
ZE_WRITE        Equate(14)      ! error writing to a file
ZE_CREAT        Equate(15)      ! couldn't open to write
ZE_PARMS        Equate(16)      ! bad command line
ZE_OPEN         Equate(18)      ! could not open a specified file to read

ZE_MAXERR       Equate(18)      ! the highest error number

WORD equate(ushort)
BOOL equate(long)

uch equate(byte)      ! unsigned 8-bit value
ush equate(short)     ! unsigned 16-bit value
ulg equate(unsigned)  ! unsigned 32-bit value

ZPOPT group
Date              ulong         ! Date to include after - cstring
szRootDir         ulong         ! Directory to use as base for zipping - cstring
szTempDir         ulong         ! Temporary directory used during zipping - cstring
fTemp             BOOL          ! Use temporary directory '-b' during zipping
fSuffix           BOOL          ! include suffixes (not implemented)
fEncrypt          BOOL          ! encrypt files
fSystem           BOOL          ! include system and hidden files
fVolume           BOOL          ! Include volume label
fExtra            BOOL          ! Exclude extra attributes
fNoDirEntries     BOOL          ! Do not add directory entries
fExcludeDate      BOOL          ! Exclude files newer than specified date
fIncludeDate      BOOL          ! Include only files newer than specified date
fVerbose          BOOL          ! Mention oddities in zip file structure
fQuiet            BOOL          ! Quiet operation
fCRLF_LF          BOOL          ! Translate CR/LF to LF
fLF_CRLF          BOOL          ! Translate LF to CR/LF
fJunkDir          BOOL          ! Junk directory names
fGrow             BOOL          ! Allow appending to a zip file
fForce            BOOL          ! Make entries using DOS names (k for Katz)
fMove             BOOL          ! Delete files added or updated in zip file
fDeleteEntries    BOOL          ! Delete files from zip file
fUpdate           BOOL          ! Update zip file--overwrite only if newer
fFreshen          BOOL          ! Freshen zip file--overwrite only
fJunkSFX          BOOL          ! Junk SFX prefix
fLatestTime       BOOL          ! Set zip file time to time of latest file in it
fComment          BOOL          ! Put comment in zip file
fOffsets          BOOL          ! Update archive offsets for SFX files
fPrivilege        BOOL          ! Use privileges (WIN32 only)
fEncryption       BOOL          ! TRUE if encryption supported, else FALSE
                                ! this is a read only flag
fRecurse          LONG          ! Recurse into subdirectories. 1 => -r, 2 => -R
fRepair           LONG          ! Repair archive. 1 => -F, 2 => -FF
fLevel            string(1)     ! Compression level ('0' - '9')
      end

! DCL structure
DCLType       group, type
ExtractOnlyNewer  long  ! true for "update" without interaction (extract only newer/new files, without queries)
SpaceToUnderScore long  ! true to convert spaces to underscore
PromptToOverwrite long  ! true to prompts to overwrite are wanted
fQuiet            long  ! 0 = all messages, 1 = few messages, 2 = no messages
ncflag            long  ! write to stdout if true
ntflag            long  ! test zip file
nvflag            long  ! verbose listing
nfflag            long  ! "freshen" (replace existing files by newer versions)
nzflag            long  ! display zip file comment
ndflag            long  ! all args are files/dir to be extracted
noflag            long  ! 1 if always overwrite files
naflag            long  ! 1 to do end-of-line translation
nZIflag           long  ! 1 to get zip info
C_flag            long  ! 1 to be case insensitive
fPrivilege        long  ! 1 => restore ACLs in user mode,
                        ! 2 => try to use OS privileges for restoring ACLs
lpszZipFN         ulong ! *cstring zip file name
lpszExtractDir    ulong ! *cstring directory to extract to, NULL indicates current directory
              end

! Callbacks
ZIPUSERFUNCTIONS group, type
print                ulong  !&DLLPRNT
comment              ulong  !&DLLCOMMENT
password             ulong  !&DLLPASSWORD
ServiceApplication   ulong  !&DLLSERVICE
                 end

UNZIPUSERFUNCTIONS group, type
Print      ulong      ! Pointer to application's print routine
Sound      ulong      ! Pointer to application's sound routine.  NULL if app doesn't use sound
Replace    ulong      ! Pointer to application's replace routine.
Password   ulong      ! Pointer to application's password routine.
Message    ulong      ! Pointer to application's routine for
                      ! displaying information about specific files in the archive
                      ! used for listing the contents of the archive.
ServiceApplication ulong ! callback function designed to be used for allowing the
                      ! app to process Windows messages, or cancelling the operation
                      ! as well as giving option of progress.  If this function returns
                      ! non-zero, it will terminate what it is doing.  It provides the app
                      ! with the name of the archive member it has just processed, as well
                      ! as the original size.
! NOTE: The values below are filled in only when listing the contents of an archive.
lTotalSizeComp ulong  ! Value to be filled in for the compressed total size, excluding
                      ! the archive header and central directory list.
lTotalSize     ulong  ! Total size of all files in the archive
lCompFactor    ulong  ! Overall archive compression factor
lNumMembers    ulong  ! Total number of files in the archive
cchComment     ushort ! Flag indicating whether comment in archive.
           end


_zip_version_type group, type
major                 uch   ! e.g., integer 5
minor                 uch   ! e.g., 2
patchlevel            uch   ! e.g., 0
not_used              uch   
                  end

ZpVer group, type
structlen    ulg          ! length of the struct being passed
flag         ulg          ! bit 0: is_beta   bit 1: uses_zlib
betalevel    string(10)   ! e.g., "g BETA" or ""
date         string(20)   ! ! e.g., "4 Sep 95" (beta) or "4 September 1995"
zlib_version string(10)   ! e.g., "0.95" or NULL
zip          like(_zip_version_type)
os2dll       like(_zip_version_type)
windll       like(_zip_version_type)
      end

ZCL group, type
argc      long        ! Count of files to zip
lpszZipFN ulong       ! name of archive to create/update
FNV       ulong       ! pointer to an array of cstring file names to zip up
    end

UzpBuffer group, type
strlength     ulg   ! length of string
strptr        ulong ! cstring
          end

 map
     module('Zip32.lib')
         ZpVersion   (*ZpVer ZpVersion), pascal, raw
         ZpInit      (ulong lpZipUserFunc), long, raw, pascal
         ZpSetOptions(ulong OptsAddress), pascal, raw, BOOL !*ZPOPT Opts), pascal, raw, BOOL
         ZpGetOptions(), long, pascal, raw  ! actually returns a ZPOPT structure
         ZpArchive   (ZCL C), long, raw, pascal 
     end
     module('UnZip32.dll')
         Wiz_SingleEntryUnzip(long ifnc, ulong ifnv, long xfnc, ulong xfnv, *DCLType lpDCL, *UNZIPUSERFUNCTIONS lpUserFunc),long,raw,pascal
         Wiz_UnzipToMemory   (ulong zip, ulong file, *UNZIPUSERFUNCTIONS lpUserFunctions, *UzpBuffer retstr),long,raw,pascal
         Wiz_NoPrinting      (long f), raw, pascal
         Wiz_Validate        (ulong archivefn, long AllCodes), long, raw, pascal
         Wiz_Grep            (ulong archive, ulong file, ulong pattern, long cmd, long SkipBin, *UNZIPUSERFUNCTIONS lpUserFunctions),long,raw,pascal
         UzpFreeMemBuffer    (*UzpBuffer retstr), raw, pascal
     end
 end

InfoZipParseQType queue, type
Tok                   string(512)
                  end

InfoZipContentQType queue,type
FN                string(512)
UncompressedSize  long
CompressedSize    long
CompressionFactor long
       end

InfoZipStatusWindow WINDOW('InfoZip'),AT(,,260,36),FONT('MS Sans Serif',8,,FONT:regular),CENTER,IMM, |
         GRAY,DOUBLE,MODAL
       STRING('Status'),AT(5,22,250,10),USE(?IZ__StatusTxt)
       PROGRESS,USE(?IZ__Progress),AT(5,9,250,8),RANGE(0,1000000) !,SMOOTH
     END


! definition of InfoZipClass
InfoZipClass class, type, module('InfoZip.clw'),link('InfoZip.clw'),link('Zip32.lib'),link('UnZip32.lib')
ZipQ                      &FLQ
ZV                        like(ZpVer)
QLock                     &ICriticalSection
ZUF                       like(ZIPUSERFUNCTIONS)
ZO                        like(ZPOPT)
ZCL                       like(ZCL)
UZUF                      like(UNZIPUSERFUNCTIONS)
DCL                       like(DCLType)

ArchiveFN                 cstring(513)

NoUI                      long
Operation                 long ! 1=zipping, 2=getting listing, 3=unzip to memory, 4=extracting
                          
StatusWindow              &window

TotalSize                 long
TotalSizeCompressed       long
lCompFactor ulong     ! Overall archive compression factor
lNumMembers ulong     ! Total number of files in the archive
cchComment  ushort    ! Flag indicating whether comment in archive.

TotalBytesSoFar           decimal(31,0)
zpPrgStrFEQ               long                ! Progress string Field Equate
zpPrgBarFEQ               long                ! Progress Bar Field Equate
TempDir                   cstring(FILE:MaxFilePath)
RootPath                  cstring(FILE:MaxFilePath)
ContentQ                  &InfoZipContentQType

Init                      procedure
Kill                      procedure

ParseStringIntoQueue procedure(string s, InfoZipParseQType PARSEQ:LocalParseQ)
AddToArchive     procedure(string WindowTitle, |
                           string ArchiveFilename, |
                           string RootDir, |           ! '' current directory
                           string FileList, |          ! semicolon separated list, wildcards ok
                           byte CreateZip=false |      ! if true, archive is deleted first
                          ), long                      ! 0 = success
GetContents      procedure(string ArchiveFilename, InfoZipContentQType CONTENTQ:LocalContentQ), long
UnzipToUzpBuffer procedure(string zip, string filename, UzpBuffer uzpbuf, <string WindowTitle>), long
FreeUzpBuffer    procedure(*UzpBuffer uzpbuf)
UnzipToCString   procedure(string zip, string filename, *cstring filebuf, <string WindowTitle>), long
ExtractArchive   procedure(string WindowTitle, |
                           string ArchiveFilename, |
                           string FileList, |          ! semicolon separated files to be extracted (wildcards ok)
                           string ExtractBaseDir |     ! directory extracted into
                          ), long                      ! 0 = success

PrintCallback    procedure(*cstring zFN), long
PasswordCallback procedure(*cstring PwdBuf, long PwdBufSize, *cstring PwdPrompt, *cstring EntryName), long
ServiceCallback  procedure(*cstring zFN, long zSize), long
CommentCallback  procedure(*cstring CommentStr)
MessageCallback  procedure(*cstring fn, ulong ucsize, ulong csize, ulong cfactor)

ErrStr           procedure(long),string
CalcPatternSize  procedure(string),long
              end

ActiveInfoZip &InfoZipClass

_EndOfInclude_
